/************************************************************************************
*                                                                                   *
*   File Name   : MAIN_MD.c                                                         *
*   Contents    : Main Loop for the Match Display                                   *
*   Version     : 1.11                                                               *
*************************************************************************************/ 

#include "globals.h"
#include "number_handling.h"
#include "output_handler.h"

extern unsigned int mk_month;
extern unsigned int mk_day;

unsigned long UL_DISP_CODE = 0;
unsigned int  UI_TIRQ_count1ms = 0;
unsigned int  UI_int0_IRQ_timestamp = 0;
unsigned int  UI_int1_IRQ_timestamp = 0;
unsigned int  UI_STATE;
unsigned int UI_CHARGER_VOLTAGE_AD = 0;
unsigned int UI_BATTERY_VOLTAGE_AD = 0;
unsigned int UI_CHARGE_STATE_PERCENT  = 0;
_Bool        B_SWITCH_PLAYER1 = D_FALSE;
_Bool        B_SWITCH_PLAYER2 = D_FALSE;
unsigned int UI_BATTERY_VOLTAGE_MV = 0;
unsigned int UI_CHARGER_VOLTAGE_MV = 0;


void main (void)
{
digits_t dt_score1;
digits_t dt_score2;
unsigned int ui_points_game_player1 = 0;
unsigned int ui_points_game_player2 = 0;
unsigned int ui_games_player1 = 0;
unsigned int ui_games_player2 = 0;
unsigned int ui_points_finish_game = 15;
unsigned int ui_switch1PressTimer = 0;
unsigned int ui_timestamp_switch1 = 0;
_Bool b_inc_player1 = D_FALSE;
_Bool b_dec_player1 = D_FALSE;
unsigned int ui_switch2PressTimer = 0;
unsigned int ui_timestamp_switch2 = 0;
_Bool b_inc_player2 = D_FALSE;
_Bool b_dec_player2 = D_FALSE;
unsigned int ui_pointsDiff = 0;
volatile unsigned int ui_previous_state = 0;
unsigned int ui_batt_empty_cnt = 0;
unsigned int ui_batt_full_cnt = 0;

    //start initialization of the uC
    f_vd_controllerInit();

    /*-----------------------------------
    -   Loop of main                    -
    -----------------------------------*/
    while(1)
    {
	UI_CHARGER_VOLTAGE_MV = UI_CHARGER_VOLTAGE_AD * D_CONV_AD_TO_MV;
    UI_BATTERY_VOLTAGE_MV = UI_BATTERY_VOLTAGE_AD * D_CONV_AD_TO_MV;
	UI_CHARGE_STATE_PERCENT = ((UI_BATTERY_VOLTAGE_MV - D_BATT_EMPTY_VOLTAGE_MV)/30);
	if (UI_CHARGE_STATE_PERCENT > 99)
	{
		UI_CHARGE_STATE_PERCENT = 99;
	}

        //Switch1 Handling
        if (ui_timestamp_switch1 != 0)
        {
           ui_switch1PressTimer = timerDifference (ui_timestamp_switch1, UI_TIRQ_count1ms);
           if ((ui_switch1PressTimer <= c2ConsecutiveSwitchPressesMs) && B_SWITCH_PLAYER1)
           {
              b_dec_player1 = D_TRUE;
              B_SWITCH_PLAYER1 = D_FALSE; //confirm pressed switch
              ui_timestamp_switch1 = 0;
           } //if ((ui_switch1PressTimer <= c2ConsecutiveSwitchPressesMs) && B_SWITCH_PLAYER1)
           else if (ui_switch1PressTimer > c2ConsecutiveSwitchPressesMs)
           {
              b_inc_player1 = D_TRUE;
              ui_timestamp_switch1 = 0;
           } //else if (ui_switch1PressTimer > c2ConsecutiveSwitchPressesMs)
        } //if (ui_timestamp_switch1 != 0)
        if (B_SWITCH_PLAYER1) //Switch 1 pressed
        {
           if (ui_timestamp_switch1 == 0)
           {
              if (UI_TIRQ_count1ms == 0)
              {
                ui_timestamp_switch1 = 1; //get timestamp of switch press
              } //(UI_TIRQ_count1ms == 0)
              else
              {
                ui_timestamp_switch1 = UI_TIRQ_count1ms; //get timestamp of switch press
              }
              B_SWITCH_PLAYER1 = D_FALSE; //confirm pressed switch
           } //if (ui_timestamp_switch1 == 0)
        } //if (B_SWITCH_PLAYER1)
        //end of Switch1 Handling 
       

        //Switch2 Handling
        if (ui_timestamp_switch2 != 0)
        {
           ui_switch2PressTimer = timerDifference (ui_timestamp_switch2, UI_TIRQ_count1ms);
           if ((ui_switch2PressTimer <= c2ConsecutiveSwitchPressesMs) && B_SWITCH_PLAYER2)
           {
              b_dec_player2 = D_TRUE;
              B_SWITCH_PLAYER2 = D_FALSE; //confirm pressed switch
              ui_timestamp_switch2 = 0;
           } //if ((ui_switch2PressTimer <= c2ConsecutiveSwitchPressesMs) && B_SWITCH_PLAYER2)
           else if (ui_switch2PressTimer > c2ConsecutiveSwitchPressesMs)
           {
              b_inc_player2 = D_TRUE;
              ui_timestamp_switch2 = 0;
           } //else if (ui_switch2PressTimer > c2ConsecutiveSwitchPressesMs)
        } //if (ui_timestamp_switch2 != 0)
        if (B_SWITCH_PLAYER2) //Switch 2 pressed
        {
           if (ui_timestamp_switch2 == 0)
           {
              if (UI_TIRQ_count1ms == 0)
              {
                ui_timestamp_switch2 = 1; //get timestamp of switch press
              } //(UI_TIRQ_count1ms == 0)
              else
              {
                ui_timestamp_switch2 = UI_TIRQ_count1ms; //get timestamp of switch press
              }
              B_SWITCH_PLAYER2 = D_FALSE; //confirm pressed switch
           } //if (ui_timestamp_switch2 == 0)
        } //if (B_SWITCH_PLAYER2)
        //end of Switch2 Handling 

        //Statemachine
        switch (UI_STATE)
	{
          case D_undefState:
	       UI_STATE = D_revDisplayState;
               break;
          case D_revDisplayState:
               if (UI_TIRQ_count1ms >= D_SHOW_REV_TIME_MS) //leave showRevState after a defined amount of time
                  {
                    UI_STATE = D_gameDisplayState;
                  }			
               break;		
          case D_gameDisplayState:
               if (b_inc_player1)
               {
                  ui_points_game_player1++;
                  b_inc_player1 = D_FALSE;    
               }
               if (b_dec_player1)
               {
                  if (ui_points_game_player1 > 0)
                  {
                    ui_points_game_player1--;
                  }
                  b_dec_player1 = D_FALSE;    
               }
               if (b_inc_player2)
               {
                  ui_points_game_player2++;
                  b_inc_player2 = D_FALSE;    
               }
               if (b_dec_player2)
               {
                  if (ui_points_game_player2 > 0)
                  {
                    ui_points_game_player2--;
                  }
                  b_dec_player2 = D_FALSE;    
               }
               ui_pointsDiff = positiveDifference(ui_points_game_player1, ui_points_game_player2);
               if ((ui_points_game_player1 == 14) && (ui_pointsDiff == 0))
               {
                  ui_points_finish_game = 17;
	       }  
               //Cond1
               else if ((ui_points_game_player1 == ui_points_finish_game) && (ui_pointsDiff > 0))
               {
                  ui_points_game_player1 = 0;
                  ui_points_game_player2 = 0;
                  ui_games_player1++;
                  UI_STATE = D_matchDisplayState;
               }
               else if ((ui_points_game_player2 == ui_points_finish_game) && (ui_pointsDiff > 0))
               {
                  ui_points_game_player1 = 0;
                  ui_points_game_player2 = 0;
                  ui_games_player2++;
                  UI_STATE = D_matchDisplayState;
               }
               //end of Cond1
               //Cond4
               if (UI_BATTERY_VOLTAGE_MV <= D_BATT_EMPTY_VOLTAGE_MV)
               {
		  ui_batt_empty_cnt++;
		  if (ui_batt_empty_cnt > 50)
		  {
                  	UI_STATE = D_battEmptyState;   
			ui_batt_empty_cnt = 0;
                  }
               }
               //end of Cond4
               //Cond5
               if (UI_CHARGER_VOLTAGE_MV >= D_CHARGER_CONNECTED_VOLTAGE_MV)
               {
                  ui_previous_state = UI_STATE;
                  UI_STATE = D_chargeState;   
               }
               //end of Cond5
               break; //D_gameDisplayState
          case D_matchDisplayState:
               //Cond2
               if (b_dec_player2)
               {
                  UI_STATE = D_gameDisplayState;
                  b_dec_player2 = D_FALSE;    
               }
               else if (b_dec_player1)
               {
                  UI_STATE = D_gameDisplayState;
                  b_dec_player1 = D_FALSE;    
               }
			   else if (b_inc_player1)
               {
                  UI_STATE = D_gameDisplayState;
                  b_inc_player1 = D_FALSE;    
               }
			   else if (b_inc_player2)
               {
                  UI_STATE = D_gameDisplayState;
                  b_inc_player2 = D_FALSE;    
               }
               //end of Cond2
               //Cond3
               if (UI_BATTERY_VOLTAGE_MV <= D_BATT_EMPTY_VOLTAGE_MV)
               {
		  ui_batt_empty_cnt++;
		  if (ui_batt_empty_cnt > 50)
		  {
                  	UI_STATE = D_battEmptyState;   
			ui_batt_empty_cnt = 0;
                  }
               }
               //end of Cond3
               //Cond5
               if (UI_CHARGER_VOLTAGE_MV >= D_CHARGER_CONNECTED_VOLTAGE_MV)
               {
                  ui_previous_state = UI_STATE;
                  UI_STATE = D_chargeState;   
               }
               //end of Cond5
               break; //D_matchDisplayState
          case D_chargeState:
               //Cond6
               if (UI_BATTERY_VOLTAGE_MV >= D_BATT_FULL_VOLTAGE_MV)
               {
		  		  ui_batt_full_cnt++;
                  if (ui_batt_full_cnt > 50)
		          {
                  	UI_STATE = D_chargeFullState;
			        ui_batt_full_cnt = 0;
		          }
               }
               //end of Cond6
               //Cond7
               else if ((UI_CHARGER_VOLTAGE_MV < D_CHARGER_CONNECTED_VOLTAGE_MV) && (ui_previous_state == D_gameDisplayState))
               {
                  UI_STATE = D_gameDisplayState; 
               }
               //end of Cond7
               //Cond8
               else if ((UI_CHARGER_VOLTAGE_MV < D_CHARGER_CONNECTED_VOLTAGE_MV) && (ui_previous_state == D_matchDisplayState))
               {
                  UI_STATE = D_matchDisplayState; 
               }
               //end of Cond8
               break; //D_chargeState
          case D_chargeFullState:
               //Cond7
               if ((UI_CHARGER_VOLTAGE_MV < D_CHARGER_CONNECTED_VOLTAGE_MV) && (ui_previous_state == D_gameDisplayState))
               {
                  UI_STATE = D_gameDisplayState; 
               }
               //end of Cond7
               //Cond8
               else if ((UI_CHARGER_VOLTAGE_MV < D_CHARGER_CONNECTED_VOLTAGE_MV) && (ui_previous_state == D_matchDisplayState))
               {
                  UI_STATE = D_matchDisplayState; 
               }
               //end of Cond8
               break; //D_chargeFullState
          case D_battEmptyState:
               //Cond5
               if (UI_CHARGER_VOLTAGE_MV >= D_CHARGER_CONNECTED_VOLTAGE_MV)
               {
                  UI_STATE = D_chargeState;   
               }
               //end of Cond5
               break; //D_battEmptyState
	} //end of Statemachine

        //Change display content state dependent
	switch (UI_STATE)
	{
		case D_revDisplayState:
			dt_score2    = f_dt_convert_to_ascii (mk_day);
			if (mk_month < 10)
			{
				dt_score1    = f_dt_convert_to_ascii (mk_month);
				UL_DISP_CODE = f_ul_calculate_7seg_codes ('R', dt_score1.ONE_COUNT_ASC, dt_score2.TEN_COUNT_ASC, dt_score2.ONE_COUNT_ASC);
			}
			else
			{
				switch (mk_month)
					case 10:
						UL_DISP_CODE = f_ul_calculate_7seg_codes ('R', 'A', dt_score2.TEN_COUNT_ASC, dt_score2.ONE_COUNT_ASC);
						break;
					case 11:
						UL_DISP_CODE = f_ul_calculate_7seg_codes ('R', 'B', dt_score2.TEN_COUNT_ASC, dt_score2.ONE_COUNT_ASC);
						break;
					case 12:
						UL_DISP_CODE = f_ul_calculate_7seg_codes ('R', 'C', dt_score2.TEN_COUNT_ASC, dt_score2.ONE_COUNT_ASC);
						break;
			}
			
			break;		
		case D_gameDisplayState:
			dt_score1    = f_dt_convert_to_ascii (ui_points_game_player1);
			dt_score2    = f_dt_convert_to_ascii (ui_points_game_player2);
			/* prevent leading zeros */
			if ((dt_score1.TEN_COUNT_ASC == 0x30) && (dt_score2.TEN_COUNT_ASC == 0x30))
			{
				UL_DISP_CODE = f_ul_calculate_7seg_codes ('Z', dt_score1.ONE_COUNT_ASC, 'Z', dt_score2.ONE_COUNT_ASC);
            }
			else if (dt_score1.TEN_COUNT_ASC == 0x30)
			{
				UL_DISP_CODE = f_ul_calculate_7seg_codes ('Z', dt_score1.ONE_COUNT_ASC, dt_score2.TEN_COUNT_ASC, dt_score2.ONE_COUNT_ASC);
            }
			else if (dt_score2.TEN_COUNT_ASC == 0x30)
			{
				UL_DISP_CODE = f_ul_calculate_7seg_codes (dt_score1.TEN_COUNT_ASC, dt_score1.ONE_COUNT_ASC, 'Z', dt_score2.ONE_COUNT_ASC);
            }
			else
			{
				UL_DISP_CODE = f_ul_calculate_7seg_codes (dt_score1.TEN_COUNT_ASC, dt_score1.ONE_COUNT_ASC, dt_score2.TEN_COUNT_ASC, dt_score2.ONE_COUNT_ASC);
            }
			break;
		case D_matchDisplayState:
			dt_score1    = f_dt_convert_to_ascii (ui_games_player1);
			dt_score2    = f_dt_convert_to_ascii (ui_games_player2);
			UL_DISP_CODE = f_ul_calculate_7seg_codes ('A', dt_score1.ONE_COUNT_ASC, 'S', dt_score2.ONE_COUNT_ASC);
			break;
		case D_chargeState:
			dt_score1    = f_dt_convert_to_ascii (UI_CHARGE_STATE_PERCENT);
			UL_DISP_CODE = f_ul_calculate_7seg_codes ('C', 'H', dt_score1.TEN_COUNT_ASC, dt_score1.ONE_COUNT_ASC);
			break;
		case D_chargeFullState:
			UL_DISP_CODE = f_ul_calculate_7seg_codes ('F', 'U', 'L', 'L');
			break;
		case D_battEmptyState:
			UL_DISP_CODE = f_ul_calculate_7seg_codes ('B', 'A', 'T', 'T');
			break;
	} //end of Change display content state dependent
    }
}
